Index: /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7885)
+++ /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7886)
@@ -155,13 +155,13 @@
       !!
       !! model state variables
-      REAL(wp) ::    zchn,zchd,zphn,zphd,zpds,zzmi
-      REAL(wp) ::    zzme,zdet,zdtc,zdin,zsil,zfer
+      REAL(wp), DIMENSION(jpi,jpj) ::    zchn,zchd,zphn,zphd,zpds,zzmi
+      REAL(wp), DIMENSION(jpi,jpj) ::    zzme,zdet,zdtc,zdin,zsil,zfer
       REAL(wp) ::    zage
 # if defined key_roam
-      REAL(wp) ::    zdic, zalk, zoxy
-      REAL(wp) ::    ztmp, zsal
+      REAL(wp), DIMENSION(jpi,jpj) ::    zdic, zalk, zoxy
+      REAL(wp), DIMENSION(jpi,jpj) ::    ztmp, zsal
 # endif
 # if defined key_mocsy
-      REAL(wp) ::    zpho
+      REAL(wp), DIMENSION(jpi,jpj) ::    zpho
 # endif
       !!
@@ -170,32 +170,33 @@
       !! AXY (23/08/13): changed from individual variables for each flux to
       !!                 an array that holds all fluxes
-      REAL(wp), DIMENSION(jp_medusa) ::    btra
+      REAL(wp), DIMENSION(jpi,jpj,jp_medusa) ::    btra
       !!
       !! primary production and chl related quantities      
-      REAL(wp)                     ::    fthetan,faln,fchn1,fchn,fjln,fprn,frn
-      REAL(wp)                     ::    fthetad,fald,fchd1,fchd,fjld,fprd,frd
+      REAL(wp), DIMENSION(jpi,jpj) ::    fthetan,faln,fchn1,fchn,fjln,fprn,frn
+      REAL(wp), DIMENSION(jpi,jpj) ::    fthetad,fald,fchd1,fchd,fjld,fprd,frd
       !! AXY (23/11/16): add in light-only limitation term (normalised 0-1 range)
-      REAL(wp)                     ::    fjlim_pn, fjlim_pd
+      REAL(wp), DIMENSION(jpi,jpj) ::    fjlim_pn, fjlim_pd
       !! AXY (03/02/11): add in Liebig terms
-      REAL(wp) ::    fpnlim, fpdlim
+      REAL(wp), DIMENSION(jpi,jpj) ::    fpnlim, fpdlim
       !! AXY (16/07/09): add in Eppley curve functionality
-      REAL(wp) ::    loc_T,fun_T,xvpnT,xvpdT
+      REAL(wp), DIMENSION(jpi,jpj) ::    fun_T,xvpnT,xvpdT
       INTEGER  ::    ieppley
       !! AXY (16/05/11): per Katya's prompting, add in new T-dependence
       !!                 for phytoplankton growth only (i.e. no change
       !!                 for remineralisation)
-      REAL(wp) ::    fun_Q10
+      REAL(wp), DIMENSION(jpi,jpj) ::    fun_Q10
       !! AXY (01/03/10): add in mixed layer PP diagnostics
-      REAL(wp), DIMENSION(jpi,jpj) ::  fprn_ml,fprd_ml
+      REAL(wp), DIMENSION(jpi,jpj) ::    fprn_ml,fprd_ml
       !!
       !! nutrient limiting factors
-      REAL(wp) ::    fnln,ffln            !! N and Fe
-      REAL(wp) ::    fnld,ffld,fsld,fsld2 !! N, Fe and Si
+      REAL(wp), DIMENSION(jpi,jpj) ::    fnln,ffln            !! N and Fe
+      REAL(wp), DIMENSION(jpi,jpj) ::    fnld,ffld,fsld,fsld2 !! N, Fe and Si
       !!
       !! silicon cycle
-      REAL(wp) ::    fsin,fnsi,fsin1,fnsi1,fnsi2,fprds,fsdiss
+      REAL(wp), DIMENSION(jpi,jpj) ::    fsin,fnsi,fprds,fsdiss
+      REAL(wp)                     ::    fsin1,fnsi1,fnsi2
       !!
       !! iron cycle; includes parameters for Parekh et al. (2005) iron scheme
-      REAL(wp) ::    ffetop,ffebot,ffescav
+      REAL(wp), DIMENSION(jpi,jpj) ::    ffetop,ffebot,ffescav
       REAL(wp) ::    xLgF, xFeT, xFeF, xFeL         !! state variables for iron-ligand system
       REAL(wp), DIMENSION(jpi,jpj) ::  xFree        !! state variables for iron-ligand system
@@ -214,39 +215,36 @@
       !!
       !! microzooplankton grazing
-      REAL(wp) ::    fmi1,fmi,fgmipn,fgmid,fgmidc
-      REAL(wp) ::    finmi,ficmi,fstarmi,fmith,fmigrow,fmiexcr,fmiresp
+      REAL(wp), DIMENSION(jpi,jpj) ::    fmi1,fmi,fgmipn,fgmid,fgmidc
+      REAL(wp), DIMENSION(jpi,jpj) ::    finmi,ficmi,fstarmi,fmith,fmigrow,fmiexcr,fmiresp
       !!
       !! mesozooplankton grazing
-      REAL(wp) ::    fme1,fme,fgmepn,fgmepd,fgmepds,fgmezmi,fgmed,fgmedc
-      REAL(wp) ::    finme,ficme,fstarme,fmeth,fmegrow,fmeexcr,fmeresp
+      REAL(wp), DIMENSION(jpi,jpj) ::    fme1,fme,fgmepn,fgmepd,fgmepds,fgmezmi,fgmed,fgmedc
+      REAL(wp), DIMENSION(jpi,jpj) ::    finme,ficme,fstarme,fmeth,fmegrow,fmeexcr,fmeresp
       !!
       !! mortality/Remineralisation (defunct parameter "fz" removed)
-      REAL(wp) ::    fdpn,fdpd,fdpds,fdzmi,fdzme,fdd
+      REAL(wp, DIMENSION(jpi,jpj)) ::    fdpn,fdpd,fdpds,fdzmi,fdzme,fdd
 # if defined key_roam
-      REAL(wp) ::    fddc
-# endif
-      REAL(wp) ::    fdpn2,fdpd2,fdpds2,fdzmi2,fdzme2
-      REAL(wp) ::    fslown, fslowc
+      REAL(wp, DIMENSION(jpi,jpj)) ::    fddc
+# endif
+      REAL(wp), DIMENSION(jpi,jpj) ::    fdpn2,fdpd2,fdpds2,fdzmi2,fdzme2
+      REAL(wp), DIMENSION(jpi,jpj) ::    fslown, fslowc
       REAL(wp), DIMENSION(jpi,jpj) ::    fslownflux, fslowcflux
-      REAL(wp) ::    fregen,fregensi
+      REAL(wp), DIMENSION(jpi,jpj) ::    fregen,fregensi
       REAL(wp), DIMENSION(jpi,jpj) ::    fregenfast,fregenfastsi
 # if defined key_roam
-      REAL(wp) ::    fregenc
+! Doesn't look like this is used - marc 10/4/17
+!      REAL(wp), DIMENSION(jpi,jpj) ::    fregenc
       REAL(wp), DIMENSION(jpi,jpj) ::    fregenfastc
 # endif
       !!
       !! particle flux
-      REAL(WP) ::    fthk,fdep,fdep1,fdep2,flat,fcaco3
-      REAL(WP) ::    ftempn,ftempsi,ftempfe,ftempc,ftempca
-      REAL(wp) ::    freminn,freminsi,freminfe,freminc,freminca
+      REAL(WP), DIMENSION(jpi,jpj) ::    fdep1,fcaco3
+      REAL(WP), DIMENSION(jpi,jpj) ::    ftempn,ftempsi,ftempfe,ftempc,ftempca
+      REAL(wp), DIMENSION(jpi,jpj) ::    freminn,freminsi,freminfe,freminc,freminca
       REAL(wp), DIMENSION(jpi,jpj) ::    ffastn,ffastsi,ffastfe,ffastc,ffastca
-      REAL(wp) ::    fleftn,fleftsi,fleftfe,fleftc,fleftca
-      REAL(wp) ::    fheren,fheresi,fherefe,fherec,fhereca
-      REAL(wp) ::    fprotf
+      REAL(wp), DIMENSION(jpi,jpj) ::    fprotf
       REAL(wp), DIMENSION(jpi,jpj) ::    fsedn,fsedsi,fsedfe,fsedc,fsedca
       REAL(wp), DIMENSION(jpi,jpj) ::    fccd
-      REAL(wp) ::    fccd_dep
-      !! AXY (28/11/16): fix mbathy bug
-      INTEGER  ::    jmbathy
+      REAL(wp), DIMENSION(jpi,jpj) ::    fccd_dep
       !!
       !! AXY (06/07/11): alternative fast detritus schemes
@@ -254,5 +252,7 @@
       !!
       !! AXY (08/07/11): fate of fast detritus reaching the seafloor
-      REAL(wp) ::    ffast2slown,ffast2slowfe,ffast2slowc
+! I don't think ffast2slowfe is used - marc 10/4/17
+!      REAL(wp), DIMENSION(jpi,jpj) ::    ffast2slown,ffast2slowfe,ffast2slowc
+      REAL(wp), DIMENSION(jpi,jpj) ::    ffast2slown,ffast2slow
       !!
       !! conservation law
@@ -299,17 +299,15 @@
       INTEGER, DIMENSION(jpi,jpj) ::     i2_omcal,i2_omarg
       !!
-      !! ROAM air-sea flux and diagnostic parameters
-      REAL(wp) ::    f_wind
       !! AXY (24/11/16): add xCO2 variable for atmosphere (what we actually have)
-      REAL(wp) ::    f_xco2a
-      REAL(wp) ::    f_ph, f_pco2w, f_h2co3, f_hco3, f_co3, f_co2flux
-      REAL(wp) ::    f_TDIC, f_TALK, f_dcf, f_henry
-      REAL(wp) ::    f_uwind, f_vwind, f_pp0
-      REAL(wp) ::    f_kw660, f_o2flux, f_o2sat, f_o2sat3
+      REAL(wp)                     ::    f_xco2a
+      REAL(wp), DIMENSION(jpi,jpj) ::    f_ph, f_pco2w, f_h2co3, f_hco3, f_co3, f_co2flux
+      REAL(wp), DIMENSION(jpi,jpj) ::    f_TDIC, f_TALK, f_dcf, f_henry
+      REAL(wp), DIMENSION(jpi,jpj) ::    f_pp0
+      REAL(wp), DIMENSION(jpi,jpj) ::    f_kw660, f_o2flux, f_o2sat, f_o2sat3
       REAL(wp), DIMENSION(jpi,jpj) ::    f_omcal, f_omarg
       !!
       !! AXY (23/06/15): additional diagnostics for MOCSY and oxygen
-      REAL(wp) ::    f_fco2w, f_BetaD, f_rhosw, f_opres, f_insitut, f_pco2atm, f_fco2atm
-      REAL(wp) ::    f_schmidtco2, f_kwco2, f_K0, f_co2starair, f_dpco2, f_kwo2
+      REAL(wp), DIMENSION(jpi,jpj) ::    f_fco2w, f_BetaD, f_rhosw, f_opres, f_insitut, f_pco2atm, f_fco2atm
+      REAL(wp), DIMENSION(jpi,jpj) ::    f_schmidtco2, f_kwco2, f_K0, f_co2starair, f_dpco2, f_kwo2
       !! jpalm 14-07-2016: convert CO2flux diag from mmol/m2/d to kg/m2/s
       REAL, PARAMETER :: weight_CO2_mol = 44.0095  !! g / mol
@@ -318,5 +316,5 @@
 
       !!
-      INTEGER  ::    iters
+      INTEGER, DIMENSION(jpi,jpj)  ::    iters
       REAL(wp) ::    f_year
       INTEGER  ::    i_year
@@ -329,11 +327,11 @@
       !!
       !! oxygen production and consumption (and non-consumption)
-      REAL(wp) ::    fo2_prod, fo2_cons, fo2_ncons, fo2_ccons
+      REAL(wp), DIMENSION(jpi,jpj) ::    fo2_prod, fo2_cons, fo2_ncons, fo2_ccons
       REAL(wp), DIMENSION(jpi,jpj) ::    foxy_prod, foxy_cons, foxy_anox
       !! Jpalm (11-08-2014)
       !! add DMS in MEDUSA for UKESM1 model
-      REAL(wp) ::    dms_surf
+      REAL(wp), DIMENSION(jpi,jpj) ::    dms_surf
       !! AXY (13/03/15): add in other DMS calculations
-      REAL(wp) ::    dms_andr, dms_simo, dms_aran, dms_hall
+      REAL(wp), DIMENSION(jpi,jpj) ::    dms_andr, dms_simo, dms_aran, dms_hall
 
 # endif
@@ -352,5 +350,5 @@
       REAL(wp), DIMENSION(jpi,jpj) :: f_runoff, f_riv_n, f_riv_si, f_riv_c, f_riv_alk
       !! AXY (19/07/12): variables for local riverine fluxes to handle inputs below surface
-      REAL(wp) ::    f_riv_loc_n, f_riv_loc_si, f_riv_loc_c, f_riv_loc_alk
+      REAL(wp), DIMENSION(jpi,jpj) :: f_riv_loc_n, f_riv_loc_si, f_riv_loc_c, f_riv_loc_alk
       !!
       !! Jpalm -- 11-10-2015 -- adapt diag to iom_use
@@ -1359,21 +1357,16 @@
                      !! do carbonate chemistry
                      !!
-                     fdep2 = fsdept(ji,jj,jk)           !! set up level midpoint
-                     !! AXY (28/11/16): local seafloor depth
-                     !!                 previously mbathy(ji,jj) - 1, now mbathy(ji,jj)
-                     jmbathy = mbathy(ji,jj)
-                     !!
                      !! set up required state variables
-                     zdic = max(0.,trn(ji,jj,jk,jpdic)) !! dissolved inorganic carbon
-                     zalk = max(0.,trn(ji,jj,jk,jpalk)) !! alkalinity
-                     ztmp = tsn(ji,jj,jk,jp_tem)        !! temperature
-                     zsal = tsn(ji,jj,jk,jp_sal)        !! salinity
+                     zdic(ji,jj) = max(0.,trn(ji,jj,jk,jpdic)) !! dissolved inorganic carbon
+                     zalk(ji,jj) = max(0.,trn(ji,jj,jk,jpalk)) !! alkalinity
+                     ztmp(ji,jj) = tsn(ji,jj,jk,jp_tem)        !! temperature
+                     zsal(ji,jj) = tsn(ji,jj,jk,jp_sal)        !! salinity
 #  if defined key_mocsy
-                     zsil = max(0.,trn(ji,jj,jk,jpsil))        !! silicic acid
-                     zpho = max(0.,trn(ji,jj,jk,jpdin)) / 16.0 !! phosphate via DIN and Redfield
+                     zsil(ji,jj) = max(0.,trn(ji,jj,jk,jpsil))        !! silicic acid
+                     zpho(ji,jj) = max(0.,trn(ji,jj,jk,jpdin)) / 16.0 !! phosphate via DIN and Redfield
 #  endif
 		     !!
 		     !! AXY (28/02/14): check input fields
-		     if (ztmp .lt. -3.0 .or. ztmp .gt. 40.0 ) then
+		     if (ztmp(ji,jj) .lt. -3.0 .or. ztmp(ji,jj) .gt. 40.0 ) then
                         IF(lwp) WRITE(numout,*) ' trc_bio_medusa: T WARNING 3D, ', &
                         tsb(ji,jj,jk,jp_tem), tsn(ji,jj,jk,jp_tem), ' at (',    &
@@ -1381,7 +1374,7 @@
 			IF(lwp) WRITE(numout,*) ' trc_bio_medusa: T SWITCHING 3D, ', &
 			tsn(ji,jj,jk,jp_tem), ' -> ', tsb(ji,jj,jk,jp_tem)
-                        ztmp = tsb(ji,jj,jk,jp_tem)     !! temperature
+                        ztmp(ji,jj) = tsb(ji,jj,jk,jp_tem)     !! temperature
                      endif
-		     if (zsal .lt. 0.0 .or. zsal .gt. 45.0 ) then
+		     if (zsal(ji,jj) .lt. 0.0 .or. zsal(ji,jj) .gt. 45.0 ) then
                         IF(lwp) WRITE(numout,*) ' trc_bio_medusa: S WARNING 3D, ', &
                         tsb(ji,jj,jk,jp_sal), tsn(ji,jj,jk,jp_sal), ' at (',    &
@@ -1390,6 +1383,6 @@
                      !!
                      !! blank input variables not used at this stage (they relate to air-sea flux)
-                     f_kw660 = 1.0
-                     f_pp0   = 1.0
+                     f_kw660(ji,jj) = 1.0
+                     f_pp0(ji,jj)   = 1.0
                      !!
                      !! calculate carbonate chemistry at grid cell midpoint
@@ -1397,33 +1390,33 @@
                      !! AXY (22/06/15): use Orr & Epitalon (2015) MOCSY-2 carbonate
                      !!                 chemistry package
-                     CALL mocsy_interface( ztmp, zsal, zalk, zdic, zsil, zpho,         &    ! inputs
-                     f_pp0, fdep2, gphit(ji,jj), f_kw660, f_xco2a, 1,                  &    ! inputs
-                     f_ph, f_pco2w, f_fco2w, f_h2co3, f_hco3, f_co3, f_omarg(ji,jj),   &    ! outputs
-                     f_omcal(ji,jj), f_BetaD, f_rhosw, f_opres, f_insitut,             &    ! outputs
-                     f_pco2atm, f_fco2atm, f_schmidtco2, f_kwco2, f_K0,                &    ! outputs
-                     f_co2starair, f_co2flux, f_dpco2 )                                     ! outputs
+                     CALL mocsy_interface( ztmp(ji,jj), zsal(ji,jj), zalk(ji,jj), zdic(ji,jj), zsil(ji,jj), zpho(ji,jj),         &    ! inputs
+                     f_pp0(ji,jj), fsdept(ji,jj,jk), gphit(ji,jj), f_kw660(ji,jj), f_xco2a, 1,                  &    ! inputs
+                     f_ph(ji,jj), f_pco2w(ji,jj), f_fco2w(ji,jj), f_h2co3(ji,jj), f_hco3(ji,jj), f_co3(ji,jj), f_omarg(ji,jj),   &    ! outputs
+                     f_omcal(ji,jj), f_BetaD(ji,jj), f_rhosw(ji,jj), f_opres(ji,jj), f_insitut(ji,jj),             &    ! outputs
+                     f_pco2atm(ji,jj), f_fco2atm(ji,jj), f_schmidtco2(ji,jj), f_kwco2(ji,jj), f_K0(ji,jj),                &    ! outputs
+                     f_co2starair(ji,jj), f_co2flux(ji,jj), f_dpco2(ji,jj) )                                     ! outputs
                      !!
-                     f_TDIC = (zdic / f_rhosw) * 1000. ! mmol / m3 -> umol / kg
-                     f_TALK = (zalk / f_rhosw) * 1000. !  meq / m3 ->  ueq / kg
-                     f_dcf  = f_rhosw
+                     f_TDIC(ji,jj) = (zdic(ji,jj) / f_rhosw(ji,jj)) * 1000. ! mmol / m3 -> umol / kg
+                     f_TALK(ji,jj) = (zalk(ji,jj) / f_rhosw(ji,jj)) * 1000. !  meq / m3 ->  ueq / kg
+                     f_dcf(ji,jj)  = f_rhosw(ji,jj)
 #  else
                      !! AXY (22/06/15): use old PML carbonate chemistry package (the
                      !!                 MEDUSA-2 default)
-                     CALL trc_co2_medusa( ztmp, zsal, zdic, zalk, fdep2, f_kw660,      &    ! inputs
-                     f_xco2a, f_ph, f_pco2w, f_h2co3, f_hco3, f_co3, f_omcal(ji,jj),   &    ! outputs
-                     f_omarg(ji,jj), f_co2flux, f_TDIC, f_TALK, f_dcf, f_henry, iters)      ! outputs
+                     CALL trc_co2_medusa( ztmp(ji,jj), zsal(ji,jj), zdic(ji,jj), zalk(ji,jj), fsdept(ji,jj,jk), f_kw660(ji,jj),      &    ! inputs
+                     f_xco2a, f_ph(ji,jj), f_pco2w(ji,jj), f_h2co3(ji,jj), f_hco3(ji,jj), f_co3(ji,jj), f_omcal(ji,jj),   &    ! outputs
+                     f_omarg(ji,jj), f_co2flux(ji,jj), f_TDIC(ji,jj), f_TALK(ji,jj), f_dcf(ji,jj), f_henry(ji,jj), iters(ji,jj))      ! outputs
                      !! 
                      !! AXY (28/02/14): check output fields
-                     if (iters .eq. 25) then
+                     if (iters(ji,jj) .eq. 25) then
                         IF(lwp) WRITE(numout,*) ' trc_bio_medusa: 3D ITERS WARNING, ', &
-                        iters, ' AT (', ji, ', ', jj, ', ', jk, ') AT ', kt
+                        iters(ji,jj), ' AT (', ji, ', ', jj, ', ', jk, ') AT ', kt
                      endif
 #  endif
                      !!
                      !! store 3D outputs
-                     f3_pH(ji,jj,jk)    = f_ph
-                     f3_h2co3(ji,jj,jk) = f_h2co3
-                     f3_hco3(ji,jj,jk)  = f_hco3
-                     f3_co3(ji,jj,jk)   = f_co3
+                     f3_pH(ji,jj,jk)    = f_ph(ji,jj)
+                     f3_h2co3(ji,jj,jk) = f_h2co3(ji,jj)
+                     f3_hco3(ji,jj,jk)  = f_hco3(ji,jj)
+                     f3_co3(ji,jj,jk)   = f_co3(ji,jj)
                      f3_omcal(ji,jj,jk) = f_omcal(ji,jj)
                      f3_omarg(ji,jj,jk) = f_omarg(ji,jj)
@@ -1432,10 +1425,10 @@
                      if (i2_omcal(ji,jj) .eq. 0 .and. f_omcal(ji,jj) .lt. 1.0) then
                         if (jk .eq. 1) then
-                           f2_ccd_cal(ji,jj) = fdep2
+                           f2_ccd_cal(ji,jj) = fsdept(ji,jj,jk)
                         else
                            fq0 = f3_omcal(ji,jj,jk-1) - f_omcal(ji,jj)
                            fq1 = f3_omcal(ji,jj,jk-1) - 1.0
                            fq2 = fq1 / (fq0 + tiny(fq0))
-                           fq3 = fdep2 - fsdept(ji,jj,jk-1)
+                           fq3 = fsdept(ji,jj,jk) - fsdept(ji,jj,jk-1)
                            fq4 = fq2 * fq3
                            f2_ccd_cal(ji,jj) = fsdept(ji,jj,jk-1) + fq4
@@ -1443,5 +1436,5 @@
                         i2_omcal(ji,jj)   = 1
                      endif
-                     if ( i2_omcal(ji,jj) .eq. 0 .and. jk .eq. jmbathy ) then
+                     if ( i2_omcal(ji,jj) .eq. 0 .and. jk .eq. mbathy(ji,jj) ) then
                         !! reached seafloor and still no dissolution; set to seafloor (W-point)
                         f2_ccd_cal(ji,jj) = fsdepw(ji,jj,jk+1)
@@ -1452,10 +1445,10 @@
                      if (i2_omarg(ji,jj) .eq. 0 .and. f_omarg(ji,jj) .lt. 1.0) then
                         if (jk .eq. 1) then
-                           f2_ccd_arg(ji,jj) = fdep2
+                           f2_ccd_arg(ji,jj) = fsdept(ji,jj,jk)
                         else
                            fq0 = f3_omarg(ji,jj,jk-1) - f_omarg(ji,jj)
                            fq1 = f3_omarg(ji,jj,jk-1) - 1.0
                            fq2 = fq1 / (fq0 + tiny(fq0))
-                           fq3 = fdep2 - fsdept(ji,jj,jk-1)
+                           fq3 = fsdept(ji,jj,jk) - fsdept(ji,jj,jk-1)
                            fq4 = fq2 * fq3
                            f2_ccd_arg(ji,jj) = fsdept(ji,jj,jk-1) + fq4
@@ -1463,5 +1456,5 @@
                         i2_omarg(ji,jj)   = 1
                      endif
-                     if ( i2_omarg(ji,jj) .eq. 0 .and. jk .eq. jmbathy ) then
+                     if ( i2_omarg(ji,jj) .eq. 0 .and. jk .eq. mbathy(ji,jj) ) then
                         !! reached seafloor and still no dissolution; set to seafloor (W-point)
                         f2_ccd_arg(ji,jj) = fsdepw(ji,jj,jk+1)
@@ -1514,51 +1507,47 @@
                !!---------------------------------------------------------------------
                !!
-               !! AXY (11/12/08): set up level thickness
-               fthk  = fse3t(ji,jj,jk)
-               !! AXY (25/02/10): set up level depth (top of level)
-               fdep  = fsdepw(ji,jj,jk)
                !! AXY (01/03/10): set up level depth (bottom of level)
-               fdep1 = fdep + fthk
+               fdep1(ji,jj) = fsdepw(ji,jj,jk) + fse3t(ji,jj,jk)
                !! AXY (28/11/16): local seafloor depth
                !!                 previously mbathy(ji,jj) - 1, now mbathy(ji,jj)
-               jmbathy = mbathy(ji,jj)
+               mbathy(ji,jj) = mbathy(ji,jj)
                !!
                !! set up model tracers
                !! negative values of state variables are not allowed to
                !! contribute to the calculated fluxes
-               zchn = max(0.,trn(ji,jj,jk,jpchn)) !! non-diatom chlorophyll
-               zchd = max(0.,trn(ji,jj,jk,jpchd)) !! diatom chlorophyll
-               zphn = max(0.,trn(ji,jj,jk,jpphn)) !! non-diatoms
-               zphd = max(0.,trn(ji,jj,jk,jpphd)) !! diatoms
-               zpds = max(0.,trn(ji,jj,jk,jppds)) !! diatom silicon
+               zchn(ji,jj) = max(0.,trn(ji,jj,jk,jpchn)) !! non-diatom chlorophyll
+               zchd(ji,jj) = max(0.,trn(ji,jj,jk,jpchd)) !! diatom chlorophyll
+               zphn(ji,jj) = max(0.,trn(ji,jj,jk,jpphn)) !! non-diatoms
+               zphd(ji,jj) = max(0.,trn(ji,jj,jk,jpphd)) !! diatoms
+               zpds(ji,jj) = max(0.,trn(ji,jj,jk,jppds)) !! diatom silicon
                !! AXY (28/01/10): probably need to take account of chl/biomass connection
-               if (zchn.eq.0.) zphn = 0.
-               if (zchd.eq.0.) zphd = 0.
-               if (zphn.eq.0.) zchn = 0.
-               if (zphd.eq.0.) zchd = 0.
+               if (zchn(ji,jj).eq.0.) zphn(ji,jj) = 0.
+               if (zchd(ji,jj).eq.0.) zphd(ji,jj) = 0.
+               if (zphn(ji,jj).eq.0.) zchn(ji,jj) = 0.
+               if (zphd(ji,jj).eq.0.) zchd(ji,jj) = 0.
 	       !! AXY (23/01/14): duh - why did I forget diatom silicon?
-	       if (zpds.eq.0.) zphd = 0.
-	       if (zphd.eq.0.) zpds = 0.
-               zzmi = max(0.,trn(ji,jj,jk,jpzmi)) !! microzooplankton
-               zzme = max(0.,trn(ji,jj,jk,jpzme)) !! mesozooplankton
-               zdet = max(0.,trn(ji,jj,jk,jpdet)) !! detrital nitrogen
-               zdin = max(0.,trn(ji,jj,jk,jpdin)) !! dissolved inorganic nitrogen
-               zsil = max(0.,trn(ji,jj,jk,jpsil)) !! dissolved silicic acid
-               zfer = max(0.,trn(ji,jj,jk,jpfer)) !! dissolved "iron"
+	       if (zpds(ji,jj).eq.0.) zphd(ji,jj) = 0.
+	       if (zphd(ji,jj).eq.0.) zpds(ji,jj) = 0.
+               zzmi(ji,jj) = max(0.,trn(ji,jj,jk,jpzmi)) !! microzooplankton
+               zzme(ji,jj) = max(0.,trn(ji,jj,jk,jpzme)) !! mesozooplankton
+               zdet(ji,jj) = max(0.,trn(ji,jj,jk,jpdet)) !! detrital nitrogen
+               zdin(ji,jj) = max(0.,trn(ji,jj,jk,jpdin)) !! dissolved inorganic nitrogen
+               zsil(ji,jj) = max(0.,trn(ji,jj,jk,jpsil)) !! dissolved silicic acid
+               zfer(ji,jj) = max(0.,trn(ji,jj,jk,jpfer)) !! dissolved "iron"
 # if defined key_roam
-               zdtc = max(0.,trn(ji,jj,jk,jpdtc)) !! detrital carbon
-               zdic = max(0.,trn(ji,jj,jk,jpdic)) !! dissolved inorganic carbon
-               zalk = max(0.,trn(ji,jj,jk,jpalk)) !! alkalinity
-               zoxy = max(0.,trn(ji,jj,jk,jpoxy)) !! oxygen
+               zdtc(ji,jj) = max(0.,trn(ji,jj,jk,jpdtc)) !! detrital carbon
+               zdic(ji,jj) = max(0.,trn(ji,jj,jk,jpdic)) !! dissolved inorganic carbon
+               zalk(ji,jj) = max(0.,trn(ji,jj,jk,jpalk)) !! alkalinity
+               zoxy(ji,jj) = max(0.,trn(ji,jj,jk,jpoxy)) !! oxygen
 #  if defined key_axy_carbchem && defined key_mocsy
-               zpho = max(0.,trn(ji,jj,jk,jpdin)) / 16.0 !! phosphate via DIN and Redfield
+               zpho(ji,jj) = max(0.,trn(ji,jj,jk,jpdin)) / 16.0 !! phosphate via DIN and Redfield
 #  endif
                !!
                !! also need physical parameters for gas exchange calculations
-               ztmp = tsn(ji,jj,jk,jp_tem)
-               zsal = tsn(ji,jj,jk,jp_sal)
+               ztmp(ji,jj) = tsn(ji,jj,jk,jp_tem)
+               zsal(ji,jj) = tsn(ji,jj,jk,jp_sal)
                !!
 	       !! AXY (28/02/14): check input fields
-               if (ztmp .lt. -3.0 .or. ztmp .gt. 40.0 ) then
+               if (ztmp(ji,jj) .lt. -3.0 .or. ztmp(ji,jj) .gt. 40.0 ) then
                   IF(lwp) WRITE(numout,*) ' trc_bio_medusa: T WARNING 2D, ', &
                   tsb(ji,jj,jk,jp_tem), tsn(ji,jj,jk,jp_tem), ' at (',    &
@@ -1566,7 +1555,7 @@
 		  IF(lwp) WRITE(numout,*) ' trc_bio_medusa: T SWITCHING 2D, ', &
                   tsn(ji,jj,jk,jp_tem), ' -> ', tsb(ji,jj,jk,jp_tem)
-                  ztmp = tsb(ji,jj,jk,jp_tem) !! temperature
+                  ztmp(ji,jj) = tsb(ji,jj,jk,jp_tem) !! temperature
                endif
-               if (zsal .lt. 0.0 .or. zsal .gt. 45.0 ) then
+               if (zsal(ji,jj) .lt. 0.0 .or. zsal(ji,jj) .gt. 45.0 ) then
                   IF(lwp) WRITE(numout,*) ' trc_bio_medusa: S WARNING 2D, ', &
                   tsb(ji,jj,jk,jp_sal), tsn(ji,jj,jk,jp_sal), ' at (',    &
@@ -1574,5 +1563,5 @@
                endif
 # else
-               zdtc = zdet * xthetad              !! implicit detrital carbon
+               zdtc(ji,jj) = zdet(ji,jj) * xthetad              !! implicit detrital carbon
 # endif
 # if defined key_debug_medusa
@@ -1612,19 +1601,19 @@
                if (idf.eq.1.AND.idfval.eq.1) then
                   IF (lwp) write (numout,*) '------------------------------'
-                  IF (lwp) write (numout,*) 'fthk(',jk,') = ', fthk
-                  IF (lwp) write (numout,*) 'zphn(',jk,') = ', zphn
-                  IF (lwp) write (numout,*) 'zphd(',jk,') = ', zphd
-                  IF (lwp) write (numout,*) 'zpds(',jk,') = ', zpds
-                  IF (lwp) write (numout,*) 'zzmi(',jk,') = ', zzmi
-                  IF (lwp) write (numout,*) 'zzme(',jk,') = ', zzme
-                  IF (lwp) write (numout,*) 'zdet(',jk,') = ', zdet
-                  IF (lwp) write (numout,*) 'zdin(',jk,') = ', zdin
-                  IF (lwp) write (numout,*) 'zsil(',jk,') = ', zsil
-                  IF (lwp) write (numout,*) 'zfer(',jk,') = ', zfer
+                  IF (lwp) write (numout,*) 'fthk(',jk,') = ', fse3t(ji,jj,jk)
+                  IF (lwp) write (numout,*) 'zphn(',jk,') = ', zphn(ji,jj)
+                  IF (lwp) write (numout,*) 'zphd(',jk,') = ', zphd(ji,jj)
+                  IF (lwp) write (numout,*) 'zpds(',jk,') = ', zpds(ji,jj)
+                  IF (lwp) write (numout,*) 'zzmi(',jk,') = ', zzmi(ji,jj)
+                  IF (lwp) write (numout,*) 'zzme(',jk,') = ', zzme(ji,jj)
+                  IF (lwp) write (numout,*) 'zdet(',jk,') = ', zdet(ji,jj)
+                  IF (lwp) write (numout,*) 'zdin(',jk,') = ', zdin(ji,jj)
+                  IF (lwp) write (numout,*) 'zsil(',jk,') = ', zsil(ji,jj)
+                  IF (lwp) write (numout,*) 'zfer(',jk,') = ', zfer(ji,jj)
 #  if defined key_roam
-                  IF (lwp) write (numout,*) 'zdtc(',jk,') = ', zdtc
-                  IF (lwp) write (numout,*) 'zdic(',jk,') = ', zdic
-                  IF (lwp) write (numout,*) 'zalk(',jk,') = ', zalk
-                  IF (lwp) write (numout,*) 'zoxy(',jk,') = ', zoxy                  
+                  IF (lwp) write (numout,*) 'zdtc(',jk,') = ', zdtc(ji,jj)
+                  IF (lwp) write (numout,*) 'zdic(',jk,') = ', zdic(ji,jj)
+                  IF (lwp) write (numout,*) 'zalk(',jk,') = ', zalk(ji,jj)
+                  IF (lwp) write (numout,*) 'zoxy(',jk,') = ', zoxy(ji,jj)                  
 #  endif
                endif
@@ -1642,46 +1631,46 @@
                   IF ( med_diag%INVTN%dgsave )   THEN
                      ftot_n(ji,jj)  = ftot_n(ji,jj) + &
-                             (fthk * ( zphn + zphd + zzmi + zzme + zdet + zdin ) )
+                             (fse3t(ji,jj,jk) * ( zphn(ji,jj) + zphd(ji,jj) + zzmi(ji,jj) + zzme(ji,jj) + zdet(ji,jj) + zdin(ji,jj) ) )
                   ENDIF
                   IF ( med_diag%INVTSI%dgsave )  THEN
                      ftot_si(ji,jj) = ftot_si(ji,jj) + & 
-                             (fthk * ( zpds + zsil ) )
+                             (fse3t(ji,jj,jk) * ( zpds(ji,jj) + zsil(ji,jj) ) )
                   ENDIF
                   IF ( med_diag%INVTFE%dgsave )  THEN
                      ftot_fe(ji,jj) = ftot_fe(ji,jj) + & 
-                             (fthk * ( xrfn * ( zphn + zphd + zzmi + zzme + zdet ) + zfer ) )
+                             (fse3t(ji,jj,jk) * ( xrfn * ( zphn(ji,jj) + zphd(ji,jj) + zzmi(ji,jj) + zzme(ji,jj) + zdet(ji,jj) ) + zfer(ji,jj) ) )
                   ENDIF
 # if defined key_roam
                   IF ( med_diag%INVTC%dgsave )  THEN
                      ftot_c(ji,jj)  = ftot_c(ji,jj) + & 
-                             (fthk * ( (xthetapn * zphn) + (xthetapd * zphd) + &
-                             (xthetazmi * zzmi) + (xthetazme * zzme) + zdtc +   &
-                             zdic ) )
+                             (fse3t(ji,jj,jk) * ( (xthetapn * zphn(ji,jj)) + (xthetapd * zphd(ji,jj)) + &
+                             (xthetazmi * zzmi(ji,jj)) + (xthetazme * zzme(ji,jj)) + zdtc(ji,jj) +   &
+                             zdic(ji,jj) ) )
                   ENDIF
                   IF ( med_diag%INVTALK%dgsave ) THEN
-                     ftot_a(ji,jj)  = ftot_a(ji,jj) + (fthk * ( zalk ) )
+                     ftot_a(ji,jj)  = ftot_a(ji,jj) + (fse3t(ji,jj,jk) * ( zalk(ji,jj) ) )
                   ENDIF
                   IF ( med_diag%INVTO2%dgsave )  THEN
-                     ftot_o2(ji,jj) = ftot_o2(ji,jj) + (fthk * ( zoxy ) )
+                     ftot_o2(ji,jj) = ftot_o2(ji,jj) + (fse3t(ji,jj,jk) * ( zoxy(ji,jj) ) )
                   ENDIF
                   !!
                   !! AXY (10/11/16): CMIP6 diagnostics
                   IF ( med_diag%INTDISSIC%dgsave ) THEN
-                     intdissic(ji,jj) = intdissic(ji,jj) + (fthk * zdic)
+                     intdissic(ji,jj) = intdissic(ji,jj) + (fse3t(ji,jj,jk) * zdic(ji,jj))
                   ENDIF
                   IF ( med_diag%INTDISSIN%dgsave ) THEN
-                     intdissin(ji,jj) = intdissin(ji,jj) + (fthk * zdin)
+                     intdissin(ji,jj) = intdissin(ji,jj) + (fse3t(ji,jj,jk) * zdin(ji,jj))
                   ENDIF
                   IF ( med_diag%INTDISSISI%dgsave ) THEN
-                     intdissisi(ji,jj) = intdissisi(ji,jj) + (fthk * zsil)
+                     intdissisi(ji,jj) = intdissisi(ji,jj) + (fse3t(ji,jj,jk) * zsil(ji,jj))
                   ENDIF
                   IF ( med_diag%INTTALK%dgsave ) THEN
-                     inttalk(ji,jj) = inttalk(ji,jj) + (fthk * zalk)
+                     inttalk(ji,jj) = inttalk(ji,jj) + (fse3t(ji,jj,jk) * zalk(ji,jj))
                   ENDIF
                   IF ( med_diag%O2min%dgsave ) THEN
-                     if ( zoxy < o2min(ji,jj) ) then
-                        o2min(ji,jj)  = zoxy
+                     if ( zoxy(ji,jj) < o2min(ji,jj) ) then
+                        o2min(ji,jj)  = zoxy(ji,jj)
                         IF ( med_diag%ZO2min%dgsave ) THEN
-                           zo2min(ji,jj) = (fdep + fdep1) / 2. !! layer midpoint
+                           zo2min(ji,jj) = (fsdepw(ji,jj,jk) + fdep1(ji,jj)) / 2. !! layer midpoint
                         ENDIF
                      endif
@@ -1701,17 +1690,4 @@
                   !! Air-sea gas exchange
                   !!----------------------------------------------------------------------
-                  !!
-                  !! AXY (17/07/14): zwind_i and zwind_j do not exist in this
-                  !!                 version of NEMO because it does not include
-                  !!                 the SBC changes that our local version has
-                  !!                 for accessing the HadGEM2 forcing; they 
-                  !!                 could be added, but an alternative approach
-                  !!                 is to make use of wndm from oce_trc.F90
-                  !!                 which is wind speed at 10m (which is what
-                  !!                 is required here; this may need to be
-                  !!                 revisited when MEDUSA properly interacts
-                  !!                 with UKESM1 physics
-                  !!
-                  f_wind  = wndm(ji,jj)
                   IF (lk_oasis) THEN
                      f_xco2a = PCO2a_in_cpl(ji,jj)        !! use 2D atm xCO2 from atm coupling
